//JoyDevice.java

public class JoyDevice {

  /* *
   * Constants used for joyid parameter of mkJoyDevice().
   */
   public final static int JDEV_ID1 = 0;
   public final static int JDEV_ID2 = 1;

  /* *
   * Constants used for idx parameter of getAxis().
   */
   public final static int AXIS_IDX_X   = 0;
   public final static int AXIS_IDX_Y   = 1;
   public final static int AXIS_IDX_Z   = 2;

  /* *
   * Constants used for idx parameter of getButton().
   */
   public final static int BTN_IDX_01 =  0;
   public final static int BTN_IDX_02 =  1;
   public final static int BTN_IDX_03 =  2;
   public final static int BTN_IDX_04 =  3;
   public final static int BTN_IDX_05 =  4;
   public final static int BTN_IDX_06 =  5;
   public final static int BTN_IDX_07 =  6;
   public final static int BTN_IDX_08 =  7;
   public final static int BTN_IDX_09 =  8;
   public final static int BTN_IDX_10 =  9;
   public final static int BTN_IDX_11 = 10;
   public final static int BTN_IDX_12 = 11;
   public final static int BTN_IDX_13 = 12;
   public final static int BTN_IDX_14 = 13;
   public final static int BTN_IDX_15 = 14;
   public final static int BTN_IDX_16 = 15;
   public final static int BTN_IDX_32 = 31;


  /* *
   * Constants used with getAllButtons().
   */
   public final static int BTN_OR_MASK_01 = 0x0001;
   public final static int BTN_OR_MASK_02 = 0x0002;
   public final static int BTN_OR_MASK_03 = 0x0004;
   public final static int BTN_OR_MASK_04 = 0x0008;
   public final static int BTN_OR_MASK_05 = 0x0010;
   public final static int BTN_OR_MASK_06 = 0x0020;
   public final static int BTN_OR_MASK_07 = 0x0040;
   public final static int BTN_OR_MASK_08 = 0x0080;
   public final static int BTN_OR_MASK_09 = 0x0100;
   public final static int BTN_OR_MASK_10 = 0x0200;
   public final static int BTN_OR_MASK_11 = 0x0400;
   public final static int BTN_OR_MASK_12 = 0x0800;
   public final static int BTN_OR_MASK_13 = 0x1000;
   public final static int BTN_OR_MASK_14 = 0x2000;
   public final static int BTN_OR_MASK_15 = 0x4000;
   public final static int BTN_OR_MASK_16 = 0x8000;
   public final static int BTN_OR_MASK_32 = 0x80000000;


  /* *
   * Instance attributes for JoyDevice.
   */
   private int    joyDeviceID;
   private double axis[]  = new double[3]; //0 - 100
   private int    amin[]  = new int[3],
                  amax[]  = new int[3];
   private long   buttons = 0;


  /* *
   * Private constructor.
   */
   private JoyDevice(int joyid) {
      joyDeviceID = joyid;
   }



  /* *
   * Returns a value between 0 and 100.00 for an Axis.
   */
   public double getAxis(int idx) {
      return axis[idx];
   }

  /* *
   * Returns a true if the button is pressed.
   */
   public boolean getButton(int idx) {
      return ((buttons & (1 << idx)) != 0);
   }

  /* *
   * Returns a value for each Axis.
   */
   public double[] getAllAxis() {
      return axis;
   }

  /* *
   * Returns a value indicating the value of all buttons.
   */
   public long getAllButtons() {
      return buttons;
   }



  /* *
   * Native Code for creating & updating a JoyDevice Object.
   */
   public  native boolean updateJoy();
   private native boolean prepJoy(int joyid);
   static {
      System.loadLibrary("jdev_w32");
   }


  /* *
   * Create an instance. 
   */
   public static JoyDevice mkJoyDevice(int joyid) {
      JoyDevice jd = new JoyDevice(joyid);
      if (jd.prepJoy(joyid))
         return jd;
      return null;
   }
}